version: '3.9'

services:
  traefik:
    ports:
      - 80:80
      - 443:443
    command:
      - --providers.docker
      - --providers.docker.exposedbydefault=false
      - --entrypoints.web.address=:80
      - --entrypoints.websecure.address=:443
      - --certificatesresolvers.le.acme.email=${EMAIL}
      - --certificatesresolvers.le.acme.tlschallenge=true
      - --certificatesresolvers.le.acme.storage=/letsencrypt/acme.json
      - --accesslog
      - --log
      - --ping
    volumes:
      - ./letsencrypt:/letsencrypt
    labels:
      - traefik.enable=true
      - traefik.http.middlewares.force-secure.redirectscheme.scheme=https
      - traefik.http.middlewares.force-secure.redirectscheme.permanent=true
      - traefik.http.routers.http-catchall.rule=HostRegexp(`{any:.+}`)
      - traefik.http.routers.http-catchall.entrypoints=web
      - traefik.http.routers.http-catchall.middlewares=force-secure

  sidekick:
    labels:
      - traefik.enable=true
      - traefik.http.routers.sidekick.rule=Host(`${MINIO_DOMAIN}`)
      - traefik.http.routers.sidekick.entrypoints=websecure
      - traefik.http.routers.sidekick.tls.certresolver=le

  console:
    labels:
      - traefik.enable=true
      - traefik.http.routers.console.rule=Host(`${MINIO_CONSOLE_DOMAIN}`)
      - traefik.http.routers.console.entrypoints=websecure
      - traefik.http.routers.console.tls.certresolver=le

